// Requires the Alert State Storage extension to work

//Global statics you may want to change
var unknownsDisappearAfter=3600*24
var normalsDisappearAfter=600


//Global Statics don't change
var badAlertMetricDestination="Alert Messages:Abnormal Alert States";
var unknownAlertMetricDestination="Alert Messages:Unknown Alert States";
var normalAlertMetricDestination="Alert Messages:Normal Alert States";
var alertStorageHost=".*Custom Metric.*";
var alertStorageMetricPattern="Alerts.*";

//Global Variables
var alertList = {};			// list of alert states
var alertStatus = {};		// alert status map
var alertStatusTime = {};   // how long alert has been at current status

var initialized=0;  //unused

function run() {

	if (initialized==0) {
    //initialize
    initialized+=1;
	}

	var i=0;  				// binding iterator

	// the following variable "bindings" is made available through 
	// the EM Javascript API; further documentation is on the community site.
	// Bindings represents the metrics matched this period.

    for(i=0; i < bindings.length; i++) {
 
 		// save the info from current binding in easy variables
        var metric = bindings[i].ESEAttribute.attributeURL;
        var agent = bindings[i].ESEProcess.processURL;
        var value = bindings[i].timeslicedValue.value;
        var time = bindings[i].timeslicedValue.startTimestampInMillis

	    // Format Alert metric text
		metric = metric.replaceAll("Alerts\\|","");  
		metric = metric.replaceAll(":","|");
		
		// add to alertList if we haven't seen the alert yet
        if (alertList[metric] == null) {
            alertList[metric] = metric;
			alertStatus[metric] = value;
			alertStatusTime[metric] = 0;  // reset "timer" 
        } else {			// end new-alert condition
        	if (alertStatus[metric] == value) {
        		alertStatusTime[metric] += 15; // same value, more time
        	} else {  		
        		alertStatusTime[metric]=0; // new value, new time
        		alertStatus[metric]=value; 
        	}  				// end different-alert-value condition
        } 					// end not-new-alert condition
	} 						// end metric binding iteration


	// used for abnormal message text
	var alertMessageText="";
	var UalertMessageText="";
	var CalertMessageText="";
	var DalertMessageText="";
	var NalertMessageText="";
	
	// used for normal and unknown metrics
	var namt = "";
	var uamt = "";

	for (var alert in alertList) {
		
		if (alertStatus[alert] == 0) {
			if (alertStatusTime[alert] < unknownsDisappearAfter) {
			UalertMessageText+="~ " + alert + " has had an unknown state for " + minutes(alertStatusTime[alert]) + " minutes.\n";
			}
			uamt+="~ " + alert + " has had an unknown state for " + minutes(alertStatusTime[alert]) + " minutes.\n";
		} else if (alertStatus[alert] == 3) {
			DalertMessageText+=" ! " + alert + " has been in the danger state for " + minutes(alertStatusTime[alert]) + " minutes.\n";
		} else if (alertStatus[alert] == 2) {
			CalertMessageText+="* " + alert + " has been in the caution state for " + minutes(alertStatusTime[alert]) + " minutes.\n";
		} else if (alertStatus[alert] == 1) {
			if (alertStatusTime[alert] < normalsDisappearAfter) {
			  NalertMessageText+="+ " + alert + " returned to the normal state " + minutes(alertStatusTime[alert]) + " minutes ago.\n";
			} 
			namt +="+ " + alert + " has been normal for " + minutes(alertStatusTime[alert]) + " minutes.\n";
		}
	} // end building alertMessageText
	
	alertMessageText = DalertMessageText + CalertMessageText + UalertMessageText + NalertMessageText;

	accumulatorFactory.getStringEveryEventDataAccumulator(
		badAlertMetricDestination).IStringEveryEventDataAccumulator_addString(alertMessageText);    
	accumulatorFactory.getStringEveryEventDataAccumulator(
		unknownAlertMetricDestination).IStringEveryEventDataAccumulator_addString(uamt);    
	accumulatorFactory.getStringEveryEventDataAccumulator(
		normalAlertMetricDestination).IStringEveryEventDataAccumulator_addString(namt);    

}

// convert seconds into minutes, Math.round()ed
function minutes(seconds) {
	return Math.round(seconds/60);
}

// required function specifies which hosts to match
function getAgentRegex() {
    return alertStorageHost;
}

// required function specifies which metrics to match
function getMetricRegex() {
    return alertStorageMetricPattern;
}
